// +build linux !darwin

// Package canbus implements the can interface communication using socketcan
package canbus

// GetFrame gets the next Frame from the socket
func (can *Socket) GetFrame() (Frame, error) {
	raw := [16]byte{}
	if n, err := can.In.Read(raw[:]); err != nil || n != 16 {
		return Frame{}, err
	}
	frame := FrameFromRaw(raw)
	return frame, nil
}

// SendFrame sends a frame
func (can *Socket) SendFrame(frame Frame) error {
	if n, err := can.Out.Write(frame.raw[:]); err != nil || n != 16 {
		return err
	}
	return can.Out.Flush()
}
