// generate webinterface from skel by running "go generate"
//go:generate go-bindata -nocompress -nomemcopy -pkg webinterface -prefix $(pwd)/skel/public -o $(pwd)/webserver/webinterface/webinterface.go $(pwd)/skel/public/...

// package main is the go entry point
package main

import (
	"fmt"
	// the root cmd
	"cant/cmd"
	// include all enabled commands
	"os"

	_ "cant/cmd/all"
)

// entrypoint
func main() {
	// execute cobra command chain
	if err := cmd.Root.Execute(); err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}
