// +build linux !darwin

package receiver

import (
	"cant/can/canbus"
	"cant/can/flowroutines/canflow"
	"cant/cmd/run"
	"cant/util/flow"
	"fmt"

	//github.com/pkg/profile"
	"github.com/spf13/cobra"
)

// init adds the seed command as subcommand to the Root
func init() {
	run.Run.AddCommand(receiver)
}

// run command
var receiver = &cobra.Command{
	Use:               "receiver",
	Short:             "run the receiver component",
	PersistentPreRun:  func(cmd *cobra.Command, args []string) {}, // overwrite pre runs
	PersistentPostRun: func(cmd *cobra.Command, args []string) {}, // overwrite post runs
	Run: func(cobraCmd *cobra.Command, args []string) {
		// defer profile.Start(profile.MemProfile).Stop()
		// defer profile.Start(profile.CPUProfile).Stop()
		// defer profile.Start(profile.BlockProfile).Stop()
		can0, err := canbus.New("can0")
		if err != nil {
			fmt.Println(err)
			return
		}
		defer can0.Close()
		reader0 := canflow.CreateReader(can0)
		writer0 := canflow.CreateWriter(can0)
		dataflow := flow.New()
		dataflow.Connect(reader0, writer0)
		dataflow.Start()
		dataflow.Join()
	},
}
